Loading...
Searching...
No Matches
DiscordDataProvider::DiscordGuildsDataProvider Class Reference

The parent class for REST APIs related to specific Discord guilds. More...

`#include <DiscordGuildsDataProvider.qc.dox.h>`

Inheritance diagram for DiscordDataProvider::DiscordGuildsDataProvider:
[legend]

## Public Member Functions

| constructor (*hash< auto > options)
| Creates the object from constructor options.
| constructor (DiscordRestClient::DiscordRestClient rest)
| Creates the object from a REST connection.
*list< hash< DataProvider::DataProviderSummaryInfo > > | getChildProviderSummaryInfo ()
| Return data provider summary info.
*string | getDesc ()
| Returns the data provider description.
string | getName ()
| Returns the data provider name.
Public Member Functions inherited from DiscordDataProvider::DiscordDataProviderBase
| constructor ()
| Creates the object.
| constructor (DiscordRestClient rest, *Logger::LoggerInterface logger)
| Creates the object.
| constructor (DiscordRestConnection conn, *Logger::LoggerInterface logger)
| Creates the object.
| setLogger (*LoggerInterface logger)
| Accepts a LoggerInterface object for logging (or clears it)

## Static Public Attributes

static hash< DataProviderInfo > | ProviderInfo
| Provider info.
static hash< DataProviderSummaryInfo > | ProviderSummaryInfo
| Provider summary info.

## Protected Member Functions

hash< string, hash< auto > > | getAllGuilds ()
| Returns access info for all tables.
*DiscordDataProviderBase | getChildProviderImpl (string name)
| Returns the given child provider or nothing if the given child is unknown.
*list< string > | getChildProviderNamesImpl ()
| Returns a list of child data provider names, if any.
hash< DataProvider::DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
Qore::Thread::Mutex | lck ()
| Metadata mutex.
Protected Member Functions inherited from DiscordDataProvider::DiscordDataProviderBase
hash< auto > | doRestCommand (string method, string path, auto body, reference< hash< auto > > info)
| Makes a REST call and returns the response; handles rate limit responses.
hash< auto > | getGuild (string id)
| Retrieves info for the given guild; must be accessible to the calling user.
bool | retry (hash< ExceptionInfo > ex, reference< int > retries)
| Returns True if the error indicates that the operation should be retried.

## Protected Attributes

hash< string, hash< auto > > | guilds
| Guild list.
Protected Attributes inherited from DiscordDataProvider::DiscordDataProviderBase
*DiscordRestConnection | conn
| The connection object used to create the REST client.
*DiscordRestClient | rest
| The REST client object for API calls.

## Additional Inherited Members

Static Public Member Functions inherited from DiscordDataProvider::DiscordDataProviderBase
static | threadWait (date wait_period)
| Wait for a given period of time.
Public Attributes inherited from DiscordDataProvider::DiscordDataProviderBase
const | MaxIoRetries = 5
| Max retries.
const | RetrySet = ...
| IO errors for REST retries.

## Detailed Description

The parent class for REST APIs related to specific Discord guilds.

## Member Function Documentation

## getChildProviderImpl()

*DiscordDataProviderBase DiscordDataProvider::DiscordGuildsDataProvider::getChildProviderImpl | ( | string | name | ) |

protected

Returns the given child provider or nothing if the given child is unknown.

Returns
  the given child provider or nothing if the given child is unknown

See also
  getChildProviderEx()

## getChildProviderNamesImpl()

*list< string > DiscordDataProvider::DiscordGuildsDataProvider::getChildProviderNamesImpl | ( |  | ) |

protected

Returns a list of child data provider names, if any.

Returns
  a list of child data provider names, if any